<?php
// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) exit;
/**
 * Get a list of all active languages.
 * @since 1.1.1
 */

 function get_active_languages() {
    if (defined('ICL_SITEPRESS_VERSION')) {
        $languages = apply_filters('wpml_active_languages', NULL, 'orderby=id&order=desc');
        if (!empty($languages)) {
            return array_map(function($lang) {
                return $lang['code'];
            }, $languages);
        }
    }

    if (function_exists('pll_languages_list')) {
        $languages = pll_languages_list();
        if (!empty($languages)) {
            return $languages;
        }
    }

    if (defined('TRP_PLUGIN_FILE')) {
        global $trp_language_manager;
        $languages = $trp_language_manager->get_active_languages();
        if (!empty($languages)) {
            return array_keys($languages);
        }
    }
    return [];
}
