<?php
// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) exit;

function xmlsbw_custom_robots_txt($output, $public) {
    $default_directives = array(
        'Disallow: /wp-admin/',
        'Allow: /wp-admin/admin-ajax.php'
    );

    $custom_robots_data = get_option('custom_robots_data', array());

    $grouped_directives = array();

    $grouped_directives['*'] = $default_directives;

    if (!empty($custom_robots_data['user_agent'])) {
        foreach ($custom_robots_data['user_agent'] as $index => $user_agent) {
            if (isset($custom_robots_data['directive'][$index]) && isset($custom_robots_data['value_data'][$index])) {
                $directive = "{$custom_robots_data['directive'][$index]}: {$custom_robots_data['value_data'][$index]}";

                if (!isset($grouped_directives[$user_agent])) {
                    $grouped_directives[$user_agent] = array();
                }
                $grouped_directives[$user_agent][] = $directive;
            }
        }
    }

    $combined_directives = array();
    foreach ($grouped_directives as $user_agent => $directives) {
        $combined_directives[] = "User-agent: $user_agent";
        $combined_directives = array_merge($combined_directives, $directives);
    }

    $sitemap_url = get_option('xmlsbw_sitemap_url');
    if(empty($sitemap_url)){
        $sitemap_url = "sitemap";
    }
    if (get_option('xmlsbw_enable_sitemap_generation') == 1) {
        $combined_directives[] = 'Sitemap: ' . home_url() . '/' . $sitemap_url . '.xml';
    }
    $output = implode("\n", $combined_directives);

    return $output;
}

?>