<?php
// If this file is called directly, abort.
if (!defined('ABSPATH'))
    exit;
require_once('header-footer.php');
/**
 * Render the settings form for tools page
 *  @since 1.0.1
 */
function xmlsbw_sitemap_tools_options()
{
    ?>
    <div class="wrap-xmlsbw">
        <div class="inner-xmlsbw">
            <div class="left-box-xmlsbw">
                <h2>
                    <?php echo esc_html__('Modify Robots.txt file'); ?>
                </h2>
                <?php settings_errors(); ?>
                <form method="post" action="" id="xmlsbw-robots-file-settings-form">
                    <table width="100%" style="margin-bottom: 10px; background-color: white;">
                        <tr>
                            <td>
                                <div id="general" class="tab-content">
                                    <table>
                                        <tr id="enable_custom_robots_file_tr">
                                            <th>
                                                <?php esc_html_e('Enable Custom Robots.txt', 'xml-sitemap-for-google'); ?>
                                            </th>
                                            <td>
                                                <div class="toggle-switch">
                                                    <input type="hidden" name="enable_custom_robots_file" value="0">
                                                    <input type="checkbox" id="enable_custom_robots_file"
                                                        name="enable_custom_robots_file" value="1" <?php checked(get_option('enable_custom_robots_file'), 1); ?>>
                                                    <label for="enable_custom_robots_file" class="toggle"></label>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr id="robots_txt_preview_tr">
                                            <th>
                                                <?php esc_html_e('Preview:', 'xml-sitemap-for-google'); ?>
                                            </th>
                                            <td>
                                                <a href="<?php echo esc_url(home_url('/robots.txt')); ?>"
                                                    class="button button-primary" target="_blank"
                                                    title="View robots.txt file"><?php esc_html_e('Show Robots.txt', 'xml-sitemap-for-google'); ?>
                                                </a>
                                            </td>
                                        </tr>
                                        <tr id="robots_txt_data_tr">
                                            <td colspan="2">
                                                <div class="scroll-table">
                                                    <table id="robots-txt-data" class="row-border scrolldown" width="100%">
                                                        <thead>
                                                            <tr>
                                                                <th>
                                                                    <?php esc_html_e('User Agent', 'xml-sitemap-for-google'); ?>
                                                                </th>
                                                                <th>
                                                                    <?php esc_html_e('Directive', 'xml-sitemap-for-google'); ?>
                                                                </th>
                                                                <th style="width:auto;">
                                                                    <?php esc_html_e('Value', 'xml-sitemap-for-google'); ?>
                                                                </th>
                                                                <th>
                                                                    <?php esc_html_e('Action', 'xml-sitemap-for-google'); ?>
                                                                </th>
                                                            </tr>
                                                        </thead>

                                                        <tbody style="width: 500px;">

                                                            <tr>
                                                                <td>
                                                                    <input style="width:100%; text-align: center;" type="text"
                                                                        name="" class="robots-user-agent" value="*" disabled>
                                                                </td>
                                                                <td>
                                                                    <select disabled>
                                                                        <option value="Disallow">
                                                                            <?php esc_html_e('Disallow', 'xml-sitemap-for-google'); ?>
                                                                        </option>
                                                                    </select>
                                                                </td>
                                                                <td>
                                                                    <input style="width:100%; text-align: center;" type="text"
                                                                        name="" class="robots-value-data" value="/wp-admin/"
                                                                        disabled>
                                                                </td>
                                                                <td>
                                                                    <button type="button"
                                                                        class="button button-secondary delete-row"
                                                                        id='delete-row-robots' disabled>
                                                                        <img src="<?php echo esc_url(XMLSBW_URL . 'admin/assets/images/delete.png'); ?>"
                                                                            alt="delete" title="Delete">
                                                                    </button>
                                                                </td>
                                                            </tr>
                                                            <tr>
                                                                <td>
                                                                    <input style="width:100%; text-align: center;" type="text"
                                                                        name="" class="robots-user-agent" value="*" disabled>
                                                                </td>
                                                                <td>
                                                                    <select disabled>
                                                                        <option value="Allow">
                                                                            <?php esc_html_e('Allow', 'xml-sitemap-for-google'); ?>
                                                                        </option>
                                                                    </select>
                                                                </td>
                                                                <td>
                                                                    <input style="width:100%; text-align: center;" type="text"
                                                                        name="" class="robots-value-data"
                                                                        value="/wp-admin/admin-ajax.php" disabled>
                                                                </td>
                                                                <td>
                                                                    <button type="button"
                                                                        class="button button-secondary delete-row"
                                                                        id='delete-row-robots' disabled>
                                                                        <img src="<?php echo esc_url(XMLSBW_URL . 'admin/assets/images/delete.png'); ?>"
                                                                            alt="delete" title="Delete">
                                                                    </button>
                                                                </td>
                                                            </tr>

                                                            <?php
                                                            $custom_robots_data = get_option('custom_robots_data', array());
                                                            if (isset($custom_robots_data['value_data']) && is_array($custom_robots_data['value_data'])) {

                                                                foreach ($custom_robots_data['value_data'] as $index => $value_data) {
                                                                    $user_agent = isset($custom_robots_data['user_agent'][$index]) ? $custom_robots_data['user_agent'][$index] : '';
                                                                    $directive = isset($custom_robots_data['directive'][$index]) ? $custom_robots_data['directive'][$index] : '';
                                                                    ?>
                                                                    <tr class="robots-txt-row">
                                                                        <td>
                                                                            <input style="width:100%; text-align: center;" type="text"
                                                                                name="custom_robots_data[user_agent][]"
                                                                                class="robots-user-agent"
                                                                                value="<?php echo esc_attr($user_agent); ?>">
                                                                        </td>
                                                                        <td>
                                                                            <select name="custom_robots_data[directive][]">
                                                                                <?php
                                                                                $directive_options = array("Allow", "Disallow", "Clean-param", "Crawl-delay");
                                                                                foreach ($directive_options as $directive_option) {
                                                                                    $selected = ($directive == $directive_option) ? 'selected' : '';
                                                                                    echo '<option value="' . esc_attr($directive_option) . '" ' . ($selected ? 'selected' : '') . '>' . esc_html(ucwords($directive_option)) . '</option>';
                                                                                }
                                                                                ?>
                                                                            </select>
                                                                        </td>
                                                                        <td>
                                                                            <input style="width:100%; text-align: center;" type="text"
                                                                                name="custom_robots_data[value_data][]"
                                                                                class="robots-value-data"
                                                                                value="<?php echo esc_attr($value_data); ?>">
                                                                        </td>
                                                                        <td>
                                                                            <button type="button"
                                                                                class="button button-secondary delete-row"
                                                                                id='delete-row-robots'>
                                                                                <img src="<?php echo esc_url(XMLSBW_URL . 'admin/assets/images/delete.png'); ?>"
                                                                                    alt="delete" title="Delete">
                                                                            </button>
                                                                        </td>
                                                                    </tr>
                                                                <?php }
                                                            }
                                                            ?>
                                                        </tbody>
                                                    </table>
                                                </div>
                                                
                                                <button type="button" id="add-new-rule"
                                                    class="button button-secondary add-new">
                                                    <?php esc_html_e('Add Rule', 'xml-sitemap-for-google'); ?>
                                                </button>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                                <?php
                                    if(get_option('premium_access_allowed') != 1){
                                    ?>
                                    <div id="pop-up-box" class="pop-up-box text-center">
                                        <table class="pop-up-table">
                                            <tr>
                                                <td style="text-align:center;"><h3>Robots.txt Editor is a Premium Feature</h3></td>                                                
                                            </tr>
                                            <tr>
                                                <td class="description">
                                                Take Control of Your Site’s Crawling with Our Robots.txt Editor. Simplify search engine optimization with tailored directives.
                                                </td>
                                            </tr>
                                            <tr class="features-row">
                                                <td class="features">
                                                    <svg xmlns="http://www.w3.org/2000/svg" width="17" height="17" viewBox="0 0 17 17" fill="none">
                                                        <g clip-path="url(#clip0_1642_43)">
                                                            <path d="M16.5871 7.49821L15.4277 6.33898C15.1525 6.06381 14.927 5.52001 14.927 5.13004V3.4906C14.927 2.71072 14.2899 2.07363 13.5102 2.07321H11.8701C11.4806 2.07321 10.9362 1.8473 10.661 1.57233L9.50173 0.413107C8.95092 -0.137702 8.04907 -0.137702 7.49826 0.413107L6.33903 1.57316C6.06361 1.84834 5.51857 2.07363 5.12988 2.07363H3.49044C2.7116 2.07363 2.07368 2.71072 2.07368 3.4906V5.13008C2.07368 5.51852 1.84822 6.06402 1.573 6.33903L0.413571 7.49825C-0.137653 8.04906 -0.137653 8.95092 0.413571 9.5026L1.573 10.6618C1.84839 10.937 2.07368 11.4823 2.07368 11.8708V13.5103C2.07368 14.2893 2.7116 14.9272 3.49044 14.9272H5.12992C5.51944 14.9272 6.06386 15.1527 6.33907 15.4277L7.4983 16.5873C8.04911 17.1377 8.95097 17.1377 9.50178 16.5873L10.661 15.4277C10.9364 15.1525 11.4806 14.9272 11.8702 14.9272H13.5103C14.2899 14.9272 14.927 14.2893 14.927 13.5103V11.8708C14.927 11.4806 15.1527 10.9368 15.4277 10.6618L16.5871 9.5026C17.1375 8.95092 17.1375 8.04902 16.5871 7.49821ZM7.37545 11.6877L4.24973 8.5616L5.25148 7.56005L7.3757 9.68426L11.7484 5.31261L12.7499 6.31416L7.37545 11.6877Z" fill="#FDBC33"></path>
                                                        </g>
                                                        <defs>
                                                            <clipPath id="clip0_1642_43">
                                                                <rect width="17" height="17" fill="white"></rect>
                                                            </clipPath>
                                                        </defs>
                                                    </svg>
                                                    <p>Robots.txt File Editor</p>
                                                </td>
                                            </tr>
                                            <tr class="unlock-row">
                                                <td>
                                                    <a href="<?php home_url() ?>/wp-admin/admin.php?page=upgrade-to-premium" class="unlock-featues">Unlock Robots.txt File Editor</a>
                                                </td>
                                                <td>
                                                    <a href="https://www.weblineindia.com/contact-us.html?utm_source=WP-Plugin&utm_medium=XML%20Sitemap%20For%20Google&utm_campaign=Free%20Support" target="_blank" class="know-all-featues">Learn more about all features</a>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                    <?php
                                    }
                                    ?>
                            </td>
                        </tr>
                    </table>
                    <div id="submit-button-tools" class="submit" style="display: flex; margin: 0; padding:0;">
                        <input type="submit" name="save_robots_file" class="button button-primary" value="Save Changes"
                            title="Updates your changes on click">
                        <div class="loader">
                            <div class="spinner">
                            </div>
                        </div>
                    </div>
                    <div class="success-message"></div>
                </form>
                <br>
            </div>
            <div class="right-box-xmlsbw">
                <?php
                xmlsbw_general_section_callback();
                ?>
            </div>
        </div>
    </div>
    <?php
    add_filter('admin_footer_text', 'xmlsbw_admin_footer');
}

/**
 * Save settings for the robots file modification based on the submitted form data.
 * This function retrieves form data submitted via POST method, sanitizes and processes it,
 * and updates the corresponding options in the WordPress database.
 * @since 1.0.1
 */
function xmlsbw_save_robots_txt_settings()
{
    if (!isset($_POST['nonce']) || !wp_verify_nonce(sanitize_text_field(wp_unslash($_POST['nonce'])), 'xmlsbw_save_robots_txt_settings_nonce')) {

        $formData = isset($_POST['formData']) ? $_POST['formData'] : '';
        $formData = filter_var($formData, FILTER_SANITIZE_STRING);
        parse_str($formData, $parsedData);

        update_option('enable_custom_robots_file', isset($parsedData['enable_custom_robots_file']) ? $parsedData['enable_custom_robots_file'] : '');
        update_option('custom_robots_data', isset($parsedData['custom_robots_data']) ? $parsedData['custom_robots_data'] : '');              

        if (get_option('enable_custom_robots_file')) {
            $htaccessPath = ABSPATH . '.htaccess';
            $newRules = <<<EOT
                        # Added by XML Sitemap For Google Plugin
                        <IfModule mod_rewrite.c>
                        RewriteRule ^robots\.txt$ /index.php?robots=1 [L]
                        </IfModule>
                        EOT;
        
            $marker = 'RewriteRule ^robots\.txt$ /index.php?robots=1 [L]';
            if (is_writable($htaccessPath)) {
                $fileContent = file_get_contents($htaccessPath);
                if (strpos($fileContent, $marker) === false) {
                    $file = fopen($htaccessPath, 'a');
                    if ($file) {
                        fwrite($file, $newRules);
                        fclose($file);
                    } else {
                        error_log('Could not open .htaccess file for appending.');
                    }
                } else {
                    error_log('The rule is already present in the .htaccess file.');
                }
            } else {
                error_log('.htaccess file is not writable.');
            }
        } 
        
        if (get_option('enable_custom_robots_file') == 0) {
        
            $htaccessPath = ABSPATH . '.htaccess';
        
            $rulesToRemove = <<<EOT
                        # Added by XML Sitemap For Google Plugin
                        <IfModule mod_rewrite.c>
                        RewriteRule ^robots\.txt$ /index.php?robots=1 [L]
                        </IfModule>
                        EOT;
        
            if (is_writable($htaccessPath)) {
                $fileContent = file_get_contents($htaccessPath);
                $updatedContent = str_replace($rulesToRemove, '', $fileContent);
                if ($updatedContent !== $fileContent) {
                    $file = fopen($htaccessPath, 'w');
                    if ($file) {
                        fwrite($file, $updatedContent);
                        fclose($file);
                    } else {
                        error_log('Could not open .htaccess file for writing.');
                    }
                } else {
                    error_log('The specified rules were not found in the .htaccess file.');
                }
            } else {
                error_log('.htaccess file is not writable.');
            }
        }     
    }
    $response_data = array(
        'success' => true,
        'message' => 'Settings Updated',
    );
    wp_send_json_success($response_data);
    die();
}
?>